package com.cringe_studios.cringe_authenticator_library.impl;

public final class HOTPChecksumProvider {
	// These are used to calculate the check-sum digits. 0  1  2  3  4  5  6  7  8  9
    private static final int[] DOUBLE_DIGITS =         { 0, 2, 4, 6, 8, 1, 3, 5, 7, 9 };
	
    private HOTPChecksumProvider() {}
    
	public static int calcChecksum(long num, int digits) {
        boolean doubleDigit = true;
        int     total = 0;
        while (0 < digits--) {
            int digit = (int) (num % 10);
            num /= 10;
            if (doubleDigit) {
                digit = DOUBLE_DIGITS[digit];
            }
            total += digit;
            doubleDigit = !doubleDigit;
        }
        int result = total % 10;
        if (result > 0) {
            result = 10 - result;
        }
        return result;
	}
	
}
